Const gfx_w=800
Const gfx_h=600
Graphics gfx_w,gfx_h,0,2
SeedRnd MilliSecs()
Global title$="FLEMBLAST"
TFormFilter 0
AppTitle title$
SetFont LoadFont("Arial",16,1)

Global timer=CreateTimer(60)

Const tile_size=32
Global map_w=48,map_h=48
;Map x,y,Layer (0=Tile, 1=Kollision, 2=Items)
Dim map(map_w,map_h,2)
Dim visible(map_w,map_h)

Const MAP_LAYER_TILE=0
Const MAP_LAYER_COLL=1
Const MAP_LAYER_ITEM=2

Global scroll_x,scroll_y

Dim map_col(1)
map_col(0)=32 Shl 16+32 Shl 8+32 ;Schwarz = Boden
map_col(1)=128 Shl 16+128 Shl 8+128 ;Grau = Wand

;Player
Global player_x,player_y,player_move
Global player_tile_x,player_tile_y
Global player_speed=4,player_frame

;Anzuzeigender Winkel entsprechend Bewegungsvariablen (siehe Funktion "player_control")
Dim player_dir(2,2)
Restore player_w
For j=0 To 2
	For i=0 To 2
		Read player_dir(i,j)
	Next
Next

;Fr Items
Global tea_counter
Global item_avail1,item_avail2
Dim item_counter(1)

;Tutorial-Vars
Dim tut_txt$(5)
Global tut_show,tut_bambus_done,tut_bambus_started,tut_lift_done

;Weiteres
Global time_start,time_split
Global level,level_final=5

;Highscroe
Dim score_current(10)
Type score
	Field sum
	Field score[10]
	Field name$
End Type
score_Load()

;Partikel
Type particle
	Field x#,y#
	Field vx#,vy#
	Field col
	Field life
End Type

;Graphiken
Const GFX_ENEMY=2
Const GFX_METEOR=3
Const GFX_ANTI=4
Const GFX_TEA=5
Const GFX_LIFT=6
Dim gfx_img(8)
For i=1 To 3
	gfx_img(i)=LoadImage(i+".png")
Next
gfx_img(GFX_ANTI)=LoadImage("3.png")

SetBuffer ImageBuffer(gfx_img(GFX_METEOR))
For y=0 To 31
	For x=0 To 31
		col=ReadPixel(x,y)
		col1=(col And $FF00)/2+(col And $FF0000) ;Meteoriten: Braun frben
		col2=(col And $FF) ;Antimaterie: Blau frben
		WritePixel x,y,col1
		WritePixel x,y,col2,ImageBuffer(gfx_img(GFX_ANTI))
	Next
Next

gfx_img(GFX_TEA)=LoadImage("5.png")

gfx_img(GFX_LIFT)=CreateImage(32,32)
SetBuffer ImageBuffer(gfx_img(GFX_LIFT))
Color 255,255,255
Rect 0,0,32,32,0
Text 16,16,"Lift",1,1

Dim gfx_player(7)
For i=0 To 7
	gfx_player(i)=CopyImage(gfx_img(1))
	MidHandle gfx_player(i)
	RotateImage gfx_player(i),i*45
Next

gfx_img(7)=LoadImage("4.png")
ScaleImage gfx_img(7),2,2
gfx_img(8)=CopyImage(gfx_img(7))
ScaleImage gfx_img(8),-1,1

Global menu_title=CreateImage(200,30)
SetBuffer ImageBuffer(menu_title)
For i=1 To Len(title$)
	Color 0,Rand(100,200),0
	Text i*20,0,Mid(title$,i,1)
Next
SetBuffer BackBuffer()
ScaleImage menu_title,2,2
MidHandle menu_title

;Sounds (Zugriff etwas unsauber ber GFX_-Konstanten)
Dim sfx(6)
sfx(0)=LoadSound("0.mp3")
For i=3 To 6
	sfx(i)=LoadSound(i+".mp3")
Next

Global game_mode
Global game_selected
Dim menu_txt$(3)
menu_txt$(0)="Fortfahren"
menu_txt$(1)="Spiel neu starten"
menu_txt$(2)="Highscore"
menu_txt$(3)="Ende"

;Hauptschleife
Repeat
	If game_mode Then
		;Spiel
		player_Control()
		player_Effect()
		
		map_Draw()
		particle_Manage()
		gfx_HUD()
		
		DrawImage gfx_player(player_frame),player_x-scroll_x,player_y-scroll_y
		
		tut_Draw()
		
		If KeyHit(1) Then
			time_split=MilliSecs()
			game_mode=False
		EndIf
	Else
		;Menu
		menu_DoAll()
	EndIf
	
	WaitTimer timer
	Flip 0:Cls
Forever

Function menu_DoAll()
	DrawBlock menu_title,400,80
	
	For i=0 To 3
		Color 255,255,255
		Rect 300,150+i*100,200,50,0
		Text 400,150+i*100+25,menu_txt$(i),1,1
		If i=game_selected Then
			Color 0,200,0
			Rect 301,151+i*100,198,48,0
			Rect 302,152+i*100,196,46,0
		EndIf
	Next
	
	If KeyHit(200) Then
		game_selected=game_selected-1
		If game_selected=-1 Then game_selected=3
	EndIf
	If KeyHit(208) Then game_selected=(game_selected+1) Mod 4
	
	If KeyHit(28) Then
		Select game_selected
			Case 0
				If level=0 Then
					If FileType("s")=1 Then
						game_Load()
					Else
						map_Load(1)
					EndIf
				EndIf
				game_mode=True
				If time_split<>0 Then
					time_start=time_start+(MilliSecs()-time_split)
				EndIf
			Case 1
				DeleteFile "s"
				map_Load(1)
				game_mode=True
			Case 2
				score_Show()
			Case 3
				End
		End Select
	EndIf
	If KeyHit(1) Then End
End Function

Function map_Load(file$)
	;Reset
	Dim visible(map_w,map_h)
	Dim item_counter(1)
	player_move=0
	tea_counter=0
	item_avail1=0
	item_avail2=0
	time_start=MilliSecs()
	time_split=0
	level=file$
	tut_show=False
	tut_bambus_done=False
	tut_bambus_started=False
	tut_lift_done=False
	;Laden
	Local reader=ReadFile(file$)
	For y=0 To map_h
		For x=0 To map_w
			map(x,y,MAP_LAYER_TILE)=ReadByte(reader)
			map(x,y,MAP_LAYER_COLL)=ReadByte(reader)
			map(x,y,MAP_LAYER_ITEM)=ReadByte(reader)
			Select map(x,y,MAP_LAYER_ITEM)
				Case 1
					player_x=x*tile_size+tile_size/2
					player_y=y*tile_size+tile_size/2
					map(x,y,MAP_LAYER_ITEM)=0
				Case GFX_ENEMY
					map(x,y,MAP_LAYER_COLL)=1
				Case GFX_METEOR
					item_avail1=item_avail1+1
				Case GFX_ANTI
					item_avail2=item_avail2+1
			End Select
		Next
	Next
	CloseFile reader
End Function

Function map_Draw()
	Local x_border=(scroll_x/tile_size)+gfx_w/tile_size+1
	Local y_border=(scroll_y/tile_size)+gfx_h/tile_size+1
	For y=(scroll_y/tile_size) To y_border
		If y>map_h Then Exit
		If y>=0 Then
			For x=(scroll_x/tile_size) To x_border
				If x>map_w Then Exit
				If x>=0 Then
					If visible(x,y) Then
						Color 0,0,map_col(map(x,y,MAP_LAYER_TILE))
						Rect x*tile_size-scroll_x,y*tile_size-scroll_y,tile_size,tile_size,1
						If map(x,y,MAP_LAYER_ITEM)>1 Then
							DrawImage gfx_img(map(x,y,MAP_LAYER_ITEM)),x*tile_size-scroll_x,y*tile_size-scroll_y
						EndIf
					EndIf
				EndIf
			Next
		EndIf
	Next
End Function

Function player_Control()
	Local move_x
	Local move_y
	
	;Eingabe
	If KeyDown(200) Then
		move_y=-player_speed
	EndIf
	If KeyDown(208) Then 
		move_y=player_speed
	EndIf
	If KeyDown(203) Then 
		move_x=-player_speed
	EndIf
	If KeyDown(205) Then 
		move_x=player_speed
	EndIf
	
	Local old_x=player_x
	Local old_y=player_y
	
	;Bewegung
	player_x=player_x+move_x
	player_y=player_y+move_y
	
	move_x=(move_x/player_speed)+1
	move_y=(move_y/player_speed)+1
	
	;Frame (Player-Drehung)
	Local temp=player_dir(move_x,move_y)
	If temp<>-1 Then player_frame=temp
	
	;Kollision
	For x=-tile_size/3 To tile_size/3 Step tile_size/3
		For y=-tile_size/3 To tile_size/3 Step tile_size/3
			If map((player_x+x)/tile_size,(player_y+y)/tile_size,MAP_LAYER_COLL)<>0 Then
				;Zurck setzen
				player_x=old_x
				player_y=old_y
			EndIf
		Next
	Next
	
	player_tile_x=player_x/tile_size
	player_tile_y=player_y/tile_size
	
	scroll_x=player_x-gfx_w/2
	scroll_y=player_y-gfx_h/2
	
	;Tee einsetzen um Bambus wegzurumen
	Local key_hit=KeyHit(57)
	For x=-1 To 1
		For y=-1 To 1
			If Abs(x)<>Abs(y) Then ;Verhindert "Eckpunkte", nur direkte Nachbarn anschauen
				If map(player_tile_x+x,player_tile_y+y,MAP_LAYER_ITEM)=2 Then
					txt$="Du befindest dich neben Bambus._"
					If tea_counter>0 Then
						txt$=txt$+"Drcke die Leertaste um ihn_mit Hilfe eines Tees zu zerbrechen."
						If key_hit Then
							map(player_tile_x+x,player_tile_y+y,MAP_LAYER_ITEM)=0
							map(player_tile_x+x,player_tile_y+y,MAP_LAYER_COLL)=0
							tea_counter=tea_counter-1
							key_hit=False
							tut_bambus_done=True
							tut_show=False
							PlaySound sfx(0)
							particle_Create(gfx_img(GFX_ENEMY),player_tile_x+x,player_tile_y+y)
						EndIf
						ok=True
					Else
						txt$=txt$+"Wenn du einen Tee dabei httest,_knntest du ihn zerstren."
					EndIf
					If tut_bambus_done=False And tut_bambus_started=False Then tut_SetInfo(txt$)
					If ok Then tut_bambus_started=True
				EndIf
			EndIf
		Next
	Next
End Function

Function player_Effect()
	;Mit Items interagieren
	Local temp=map(player_tile_x,player_tile_y,MAP_LAYER_ITEM)
	Select temp
		Case GFX_METEOR,GFX_ANTI
			item_counter(temp-3)=item_counter(temp-3)+1
			map(player_tile_x,player_tile_y,MAP_LAYER_ITEM)=0
			PlaySound sfx(temp)
			If item_counter(0)=item_avail1 And item_counter(1)=item_avail2 Then
				tut_SetInfo("Du hast alle Items in diesem Stockwerk,_begib dich zum Lift um richtig loszulegen!")
			Else
				txt$="Das war gerade "
				If temp=GFX_METEOR Then
					txt$=txt$+"ein Meteorit!"
				Else
					txt$=txt$+"eine Antimaterie!"
				EndIf
				txt$=txt$+"_Beachte die Anzeige oben um zu sehen_wann du alle Items eingesammelt hast."
				tut_SetInfo(txt$)
			EndIf
			particle_Create(gfx_img(temp),player_tile_x,player_tile_y)
		Case GFX_TEA
			tea_counter=tea_counter+1
			map(player_tile_x,player_tile_y,MAP_LAYER_ITEM)=0
			PlaySound sfx(temp)
			tut_SetInfo("Du hast gerade Tee aufgesammelt._Spter wirst du ihn brauchen.")
			particle_Create(gfx_img(temp),player_tile_x,player_tile_y)
		Case GFX_LIFT
			If item_counter(0)=item_avail1 And item_counter(1)=item_avail2 Then
				score_current(level)=(MilliSecs()-time_start)/1000
				PlaySound sfx(6)
				If level=level_final Then
					tut_SetInfo("Du bist im obersten Stockwerk._Nur dort findet sich kein Scheinwerfer..._Nein, ein gespiegelter Elefant begrt dich.",True)
					tut_DrawFinal()
					tut_SetInfo("Er spricht sehr weise Worte,_die du als Frosch leider nicht verstehst._Irgendwas soll mit deinen gesammelten_Meteoriten und der Antimaterie sein.",True)
					tut_DrawFinal()
					tut_SetInfo("Doch mehr als 'Du hast die Welt gerettet'_war ihm letztendlich nicht zu entlocken.",True)
					tut_DrawFinal()
					tut_SetInfo("Als Belohnung bietet er dir_einen Highscore-Eintrag an.",True)
					tut_DrawFinal()
					score_Save()
					game_mode=False
					level=0
					score_Show()
				Else
					map_Load(level+1)
					game_Save()
				EndIf
			Else
				If Not tut_lift_done Then tut_SetInfo("Erst wenn du alle Items gesammelt hast_kannst du in das nchste Stockwerk")
				tut_lift_done=True
			EndIf
	End Select
	
	;Sicht-Radius
	For w=0 To 350 Step 10
		For r=0 To 5*tile_size Step tile_size
			x=player_x+r*Cos(w)
			y=player_y+r*Sin(w)
			x_tile=x/tile_size
			y_tile=y/tile_size
			If x_tile>=0 And y_tile>=0 And x_tile<=map_w And y_tile<=map_h Then
				visible(x_tile,y_tile)=1
				If map(x_tile,y_tile,MAP_LAYER_COLL)<>0 Then Exit
			EndIf
		Next
	Next
End Function

Function gfx_HUD()
	Color 0,0,0
	Rect 0,0,gfx_w,20,1
	If item_counter(0)=item_avail1 Then
		Color 0,200,0
	Else
		Color 200,0,0
	EndIf
	Text 165,2,"Meteoriten: "+item_counter(0)+"/"+item_avail1
	If item_counter(1)=item_avail2 Then
		Color 0,200,0
	Else
		Color 200,0,0
	EndIf
	Text 325,2,"Antimaterie: "+item_counter(1)+"/"+item_avail2
	Color 255,255,255
	Text 5,2,"Tee: "+tea_counter
	Text 485,2,"Etage: "+level
	Text 645,2,"Zeit: "+((MilliSecs()-time_start)/1000)+"s"
	Line 0,20,gfx_w,20
End Function

Function tut_SetInfo(txt$,force=False)
	If level=1 Or force Then
		For i=0 To 5
			tut_txt$(i)=""
		Next
		Local index=0
		For i=1 To Len(txt$)
			char$=Mid(txt$,i,1)
			If char$="_" Then
				index=index+1
			Else
				tut_txt$(index)=tut_txt$(index)+char$
			EndIf
		Next
		tut_txt$(index+1)="(Drcke Enter)"
		tut_show=True
		FlushKeys()
	EndIf
End Function

Function tut_Draw()
	If tut_show Then
		Color 0,0,0
		Rect 250,230,300,140,1
		Color 255,255,255
		Rect 250,230,300,140,0
		For i=0 To 5
			Text gfx_w/2,230+i*20,tut_txt$(i),1
		Next
		If KeyHit(28) Then tut_show=False
	EndIf
End Function

Function tut_DrawFinal()
	Repeat
		tut_Draw()
		DrawImage gfx_img(7),gfx_w/2,50
		DrawImage gfx_img(8),gfx_w/2,50
		WaitTimer timer
		Flip 0:Cls
	Until tut_show=False
End Function

Function game_Save()
	Local writer=WriteFile("s")
	For i=1 To level_final
		WriteShort writer,score_current(i)
	Next
	CloseFile writer
End Function

Function game_Load()
	Local reader=ReadFile("s")
	For i=1 To level_final
		score_current(i)=ReadShort(reader)
		If score_current(i)=0 Then
			level=i
			Exit
		EndIf
	Next
	map_Load(level)
	CloseFile reader
End Function

Function score_Show()
	y=50
	Cls
	If First score=Null Then
		Color 200,0,0
		Text gfx_w/2,gfx_h/2,"Keine Highscore-Eintrge vorhanden",1,1
	Else
		For hs.score=Each score
			Color 255,255,255
			Text 10,y,hs\name$
			For i=1 To level_final
				Text 150+i*40,y,hs\score[i]
			Next
			Color 0,200,0
			Text 150+(level_final+1)*40,y,"= "+hs\sum
			y=y+20
		Next
	EndIf
	Flip 0
	FlushKeys()
	WaitKey()
	FlushKeys()
End Function

Function score_Load()
	Local reader=ReadFile("hs")
	If reader=0 Then Return
	While Not Eof(reader)
		hs.score=New score
		For i=1 To level_final
			hs\score[i]=ReadShort(reader)
			hs\sum=hs\sum+hs\score[i]
		Next
		hs\name$=ReadString(reader)
	Wend
	CloseFile reader
End Function

Function score_Save()
	Local sum=0
	For i=1 To level_final
		sum=sum+score_current(i)
	Next
	Cls
	Locate 300,350
	FlushKeys()
	Local name$=Input("Bitte Namen eingeben: ")
	FlushKeys()
	Local writer=WriteFile("hs")
	;Neuer Eintrag
	Local hs.score=New score
	hs\name$=name$
	For i=1 To level_final
		hs\score[i]=score_current(i)
		hs\sum=hs\sum+hs\score[i]
	Next
	;Einsortieren
	For hs2.score=Each score
		If hs\sum<hs2\sum Then
			Insert hs Before hs2
			Exit
		EndIf
	Next
	;Alles Speichern
	For hs.score=Each score
		For i=1 To level_final
			WriteShort writer,hs\score[i]
		Next
		WriteString writer,hs\name$
	Next
	CloseFile writer
	DeleteFile("s") ;Speicherstand zurck setzen
End Function

Function particle_Create(img,x,y)
	Local p.particle
	Local w=ImageWidth(img)
	Local h=ImageHeight(img)
	Local buff=ImageBuffer(img)
	For yy=0 To h-1
		For xx=0 To w-1
			col=ReadPixel(xx,yy,buff)
			If col<>-16777216 Then ;Nur nicht-schwarze Pixel "explodieren" lassen
				p=New particle
				p\x=(x+0.5)*tile_size ;In der Mitte eines Tiles ansetzen
				p\y=(y+0.5)*tile_size
				w=Rand(0,360)
				p\vx=Cos(w)*Rnd(0.3,1.5)
				p\vy=Sin(w)*Rnd(0.3,1.5)
				p\col=col
				p\life=Rand(30,50)
			EndIf
		Next
	Next
End Function

Function particle_Manage()
	Local p.particle
	For p=Each particle
		WritePixel p\x-scroll_x,p\y-scroll_y,p\col
		p\x=p\x+p\vx
		p\y=p\y+p\vy
		p\life=p\life-1
		If p\life=0 Then Delete p
	Next
End Function

.player_w
Data 7, 0,1
Data 6,-1,2
Data 5, 4,3
;~IDEal Editor Parameters:
;~C#Blitz3D