' Skillophant von Tennisball
' fr den BCC#60


SuperStrict


'Vektor-Type
Type TVector
	
	'Koordinaten
	Field X:Float
	Field Y:Float
	
	'Initialisierung
	Method Init:TVector( _X:Float, _Y:Float )
		Self.X = _X
		Self.Y = _Y
		Return Self
	End Method
	
	'Addieren
	Method Add( Vector2:TVector )
		Self.X :+ Vector2.X
		Self.Y :+ Vector2.Y
	End Method
	
	'Subtrahieren
	Method Sub( Vector2:TVector )
		Self.X :- Vector2.X
		Self.Y :+ Vector2.Y
	End Method
	
End Type


'Spiegelsegment-Type
Type TSegment
	
	'ID
	Field ID:Int
	
	'Linienkoordinaten
	Field P1:TVector
	Field P2:TVector
	
	'Mittelposition und Rotation
	Field MP:TVector
	Field Rotation:Float
	
	'Konstruktor
	Method New()
		Self.P1 = New TVector
		Self.P2 = New TVector
	End Method
	
	'Initialisierung
	Method Init( _ID:Int, _MP:TVector, _Rotation:Float = 0.0 )
		Self.ID = _ID
		Self.MP = _MP
		Self.Rotation = _Rotation
		UpdateLineCoordinates()
	End Method
	
	'Position und Rotation ndern
	Method ChangePosRot( _MP:TVector, _Rotation:Float )
		Self.MP = _MP
		Self.Rotation = _Rotation
		UpdateLineCoordinates()
	End Method
	
	'Rendern
	Method Render()
		SetRotation Self.Rotation
		DrawImage Game.Ressources.gfx_mirror, Self.MP.X, Self.MP.Y
		SetRotation 0
	End Method
	
	'Schatten rendern
	Method RenderShadow()
		'SetRotation Self.Rotation
		'DrawImage Game.Ressources.gfx_mirrorshadow, Self.MP.X+5, Self.MP.Y +10
		'SetRotation 0
		'DrawLine Self.p1.x, Self.p1.y, Self.p2.x, Self.p2.y
		
		SetAlpha 0.07
		Local X1:Int = Self.P1.X + 3	'Start-X
		Local Y1:Int = Self.P1.Y + 6	'Start-Y
		Local A:Float = ( ATan2( Self.P2.Y - Self.P1.Y, Self.P2.X - Self.P1.X ) + 360 ) Mod 360		'Winkel
		Local I:Int						'Index
		Local X:Int						'Schatten-X
		Local Y:Int						'Schatten-Y
		For I = 0 To 31
			X = X1 + Cos( A ) * I
			Y = Y1 + Sin( A ) * I
			DrawImage Game.Ressources.gfx_shadow, X, Y
		Next
		SetAlpha 1
	End Method
	
	'Linienkoordinaten bestimmen
	Method UpdateLineCoordinates()
		Self.P1.X = Self.MP.X + Cos( Self.Rotation ) * 16
		Self.P1.Y = Self.MP.Y + Sin( Self.Rotation ) * 16
		Self.P2.X = Self.MP.X + Cos( Self.Rotation ) * -16
		Self.P2.Y = Self.MP.Y + Sin( Self.Rotation ) * -16	
	End Method
	
End Type


'Sprite-Type
Type TSprite
	
	'ID
	Field ID:Int
	
	'Position, Rotation
	Field Position:TVector
	Field Rotation:Float
	
	'Image
	Field Img:TImage
	
	'Initialisierung
	Method Init( _ID:Int, _Img:TImage, _Position:TVector, _Rotation:Float = 0.0 )
		Self.ID = _ID
		Self.Img = _Img
		Self.Position = _Position
		Self.Rotation = _Rotation
	End Method
	
	'Position und Rotation ndern
	Method ChangePosRot( _Position:TVector, _Rotation:Float )
		Self.Position = _Position
		Self.Rotation = _Rotation
	End Method
	
	'Rendern
	Method Render()
		SetRotation Self.Rotation
		DrawImage Self.Img, Self.Position.X, Self.Position.Y
		SetRotation 0
	End Method
	
End Type


'Spiegeldings-Type
Type TObject
	
	'ID
	Field ID:Int
	
	'LUA-Name
	Field Name:String
	
	'Segment-Liste
	Field SegmentList:TList
	
	'Sprite-Liste
	Field SpriteList:TList
	
	'Tags
	Field Tags:Int[]
	
	'Ob es geupdatet werden soll
	Field UpdateFlag:Byte
	
	'Ob man es sieht
	Field Visible:Byte
	
	'Konstruktor
	Method New()
		'Listen erstellen
		Self.SegmentList = New TList
		Self.SpriteList = New TList
		
		'Standardmig aktiviert
		Self.Visible = True
	End Method
	
	'Updaten
	Method Update()
		'Lua-Funktion aufrufen
		lua_getfield( LuaState, LUA_GLOBALSINDEX, Self.Name + "_update" )
		
		'ID pushen
		lua_pushinteger( LuaState, Self.ID )
		
		'Tags pushen
		Local i:Int
		For i = EachIn Self.Tags
			lua_pushinteger( LuaState, i )
		Next
		
		lua_pcall( LuaState, 1+Self.Tags.Length, 0, 0 )
	End Method
	
	'Tags updaten
	Method UpdateTags( _LuaState:Byte Ptr )
		Local i:Int
		For i = 0 To Self.Tags.Length - 1
			Self.Tags[ i ] = luaL_checkinteger( _LuaState, 2 + i )
		Next
	End Method
	
	'Rendern
	Method Render()
		'Alle Segmentschatten rendern
		Local Segment:TSegment
		For Segment = EachIn Self.SegmentList
			Segment.RenderShadow()
		Next
		'Alle Segmente rendern
		SetAlpha 0.7
		For Segment = EachIn Self.SegmentList
			Segment.Render()
		Next
		SetAlpha 1
		
		'Alle Sprites rendern
		Local Sprite:TSprite
		For Sprite = EachIn Self.SpriteList
			Sprite.Render()
		Next
	End Method
	
End Type


'Player-Type
Type TPlayer
	
	'Position
	Field Position:TVector
	
	'Alte Position
	Field OldPosition:TVector
	
	'Ob er im Kfig ist
	Field Caged:Byte
	
	'In welche Richtung er schaut
	Field Rotation:Float
	
	'Skalierung
	Field Scale:Float
	
	'Konstruktor
	Method New()
		Self.Position = New TVector
		Self.OldPosition = New TVector
	End Method
	
	'Methode zum Position setzen
	Method SetPosition( _X:Int, _Y:Int )
		
		'Position ndern
		Self.Position.Init( _X, _Y )
		Self.OldPosition.Init( _X, _Y )
		
		'Maus dahin bewegen
		MoveMouse( _X, _Y )
				
		'Elefant guckt nach rechts / unskaliert
		Self.Rotation = 0
		Self.Scale = 1
		
	End Method
	
	'Methode zum Updaten
	Method Update()
		
		'Alte Position speichern
		Self.OldPosition = Self.Position
		
		'Neue Position ermitteln
		Local NewX:Int = Game.Inputs.MouseXPos
		Local NewY:Int = Game.Inputs.MouseYPos
		
		'Neue Position setzen
		Self.Position = New TVector.Init( NewX, NewY )
		
		'Falls es sich verndert hat und die Zeit noch nicht angefangen hat zu zhlen, jetzt damit anfangen
		Local Stayed:Byte = ( ( Self.OldPosition.X = Self.Position.X ) And ( Self.OldPosition.Y = Self.Position.Y ) )
		If ( ( Stayed = False ) And ( IngameState.Map.StartTime = -1 ) ) Then
			IngameState.Map.StartTime = Game.Inputs.Milliseconds
		End If
		
		'Falls keine Antimaterien mehr vorhanden sind, "Siegesfunktion" aufrufen
		If ( IngameState.Map.AntimatterList.IsEmpty() ) Then
			Self.Win()
		End If
		
		'Falls Spieler auf R (Reset) drckt, resetten
		If Game.Inputs.KHR = True Then Self.Die()
		
		'Auf Kollision mit Antimaterie prfen
		Local Antimatter:TAntimatter
		Local Col1:Byte, Col2:Byte
		Local LSX:Int, LSY:Int, LDX:Int, LDY:Int
		For Antimatter = EachIn IngameState.Map.AntimatterList
			Col1 = CircleCircleCollision( Self.Position, 14, Antimatter.Position, 14 )
			LSX = Self.OldPosition.X
			LSY = Self.OldPosition.Y
			LDX = LSX - Self.Position.X
			LDY = LSY - Self.Position.Y
			Col2 = CircleIntersect( LSX, LSY, LDX, LDY, Antimatter.Position.X, Antimatter.Position.Y, 16 )
			If Col1 Or Col2 Then Antimatter.Del = True
		Next
		
		'Auf Kollision mit allen Segmenten prfen
		Local obj:TObject
		Local seg:TSegment
		Local OPPX:Int = Self.OldPosition.X	'alte Spieler-X-Position
		Local OPPY:Int = Self.OldPosition.Y	'alte Spieler-Y-Position
		Local collided:Byte = False
		
		For obj = EachIn IngameState.Map.ObjectList
			If obj.Visible = True Then
				For seg = EachIn obj.SegmentList
					'Linie zwischen alten und neuen Koordinaten auf Kollision prfen
					Local Col1:Byte = ( LinesCollide( OPPX - 10, OPPY, NewX - 10, NewY, seg.p1.x, seg.p1.y, seg.p2.x, seg.p2.y ) = True )
					Local Col2:Byte = ( LinesCollide( OPPX + 10, OPPY, NewX + 10, NewY, seg.p1.x, seg.p1.y, seg.p2.x, seg.p2.y ) = True )
					Local Col3:Byte = ( LinesCollide( OPPX, OPPY - 10, NewX, NewY - 10, seg.p1.x, seg.p1.y, seg.p2.x, seg.p2.y ) = True )
					Local Col4:Byte = ( LinesCollide( OPPX, OPPY + 10, NewX, NewY + 10, seg.p1.x, seg.p1.y, seg.p2.x, seg.p2.y ) = True )
					
					'Neue Position mit Kreis-Linien-Kollisionsabfrage prfen
					Local Col5:Byte = ( CircleIntersect( seg.p1.x, seg.p1.y, seg.p2.x - seg.p1.x, seg.p2.y - seg.p1.y, NewX, NewY, 16 ) = True )
					
					If Col1 Or Col2 Or Col3 Or Col4 Or Col5 Then
						collided = True
						Exit
					End If
				Next
				
				If collided = True Then Exit
			End If
		Next
		
		If collided = True Then Self.Die()
		
		'In welche Richtung er schaut
		Local dist:Float = Sqr( ( OPPX - NewX )^2 + ( OPPY - NewY )^2 )
		Local angle:Float = ( ATan2( NewY - OPPY, NewX - OPPX ) + 360 ) Mod 360
		If dist >= 4 Then
			If angle > 90 And angle < 270 Then
				Self.Scale = -1
				Self.Rotation = angle + 180
			Else
				Self.Scale = 1
				Self.Rotation = angle
			End If
		End If
		Self.Rotation = Self.Rotation Mod 360
		
	End Method
	
	'Rendern
	Method Render()
		
		'Rotation setzen und Bild malen
		'SetRotation Self.Rotation
		If MenuState.ChosenMappack.Name = "Skill Rabbit" Then
			DrawImage Game.Ressources.gfx_rabbit, Self.Position.X, Self.Position.Y
		Else
			'Schatten
			Self.RenderShadow()
			SetRotation Self.Rotation
			SetScale Self.Scale, 1
			DrawImage Game.Ressources.gfx_elephant, Self.Position.X, Self.Position.Y
			SetRotation 0
			SetScale 1, 1
		End If
		
		'Kfig malen, falls ntig
		If Self.Caged = True Then DrawImage Game.Ressources.gfx_cage, Self.Position.X, Self.Position.Y
		
	End Method
	
	'Schatten rendern
	Method RenderShadow()
		Local CX:Int = Self.Position.X + 3
		Local CY:Int = Self.Position.Y + 4
		Local X:Int
		Local Y:Int
		Local A:Int
		SetAlpha 0.02
		For A = 0 To 359
			X = CX + Cos( A ) * 9
			Y = CY + Sin( A ) * 9
			DrawImage Game.Ressources.gfx_shadow, X, Y
		Next
		SetAlpha 1
	End Method
	
	'Spieler rennt gegen einen Spiegel
	Method Die()
		IngameState.Map.LoadMap( IngameState.Map.Name )
	End Method
	
	'Spieler hat alle Antimaterien eingesammelt
	Method Win()
		Local Map:TGameMap = IngameState.Map
		Map.StartTime = -1
		If ( ( Map.BestTime = 0 ) Or ( Map.CurrTime < Map.BestTime ) ) Then
			Map.SetBestTime()
		End If
		
		'Bei Mausklick nchste Map starten
		If ( Game.Inputs.MouseHitLeft = True ) Then
			If IngameState.MapNr + 1 < CountList( MenuState.ChosenMappack.MapList ) Then 
				Local NextMap:TGameMap = TGameMap( MenuState.ChosenMappack.MapList.ValueAtIndex( IngameState.MapNR + 1 ) )
				IngameState.Map.LoadMap( NextMap.Name )
				IngameState.MapNR :+ 1
			Else
				ShowMouse()
				Game.ActiveGamestate = WinState
			End If
		End If
		
	End Method
	
End Type


'Antimaterie-Type
Type TAntimatter
	
	'Position
	Field Position:TVector
	
	'Frame
	Field Frame:Int
	
	'Ob sie gelscht werden soll
	Field Del:Byte
	
	'Initialisierung
	Method Init( X:Int, Y:Int )
		Self.Position = New TVector.Init( X, Y )
	End Method
	
	'Updaten
	Method Update()
		
		'Animationsframe erhhen
		Self.Frame = ( Self.Frame + 1 ) Mod 45
		
	End Method
	
	'Rendern
	Method Render()
		Local a:Float
		Local x:Int
		Local y:Int
		SetColor 0,0,255
		DrawOval 12 + Self.Position.X-16,14 + Self.Position.Y-16,4,4
		DrawOval 15 + Self.Position.X-16,14 + Self.Position.Y-16,4,4
		SetColor 255, 0, 0
		a = Self.Frame * 8
		x = 16 + Cos( a ) * 8 + Sin( a ) * 6 - 1 + Self.Position.X-16
		y = 16 + Sin( a ) * 10-1 + Self.Position.Y-16
		DrawOval x,y,2,2
		SetColor 255,100,255
		Plot x,y
		SetColor 255,0,0
		x = 16 - Cos( a ) * 10 - 1 + Self.Position.X-16
		y = 16 - Sin( a ) * 6 - 1 + Self.Position.Y-16
		DrawOval x,y,2,2
		SetColor 255,100,255
		Plot x,y
		SetColor 255, 255, 255
	End Method
	
	'Schatten rendern
	Method RenderShadow()
		SetAlpha 0.4
		DrawImage Game.Ressources.gfx_shadow, Self.Position.X - 1, Self.Position.Y + 4
		DrawImage Game.Ressources.gfx_shadow, Self.Position.X + 2, Self.Position.Y + 4
		SetAlpha 1
	End Method
	
End Type


'Mappack-Type
Type TMapPack
	
	'Name
	Field Name:String
	
	'Ob es im Men ausgewhlt ist oder gerade gespielt wird
	Field Selected:Byte
	
	'Maps in einer Liste
	Field MapList:TList
	
	'Ob man in allen Maps die Goldmedaille hat
	Field GoldMedal:Byte
	
	'Methode zum Laden der Maps bzw ob man die Goldmedaillen hat
	Method Load( _Name:String )
		
		'Mapliste erstellen
		Self.MapList = New TList
		
		'Name zuweisen
		Self.Name = _Name
		
		'Mappack-Datei ffnen
		Local stream:TStream = ReadFile( "mappacks\" + _Name )
		
		'Man hat alle Medaillen. Ist dem nicht so, wird das in der weiter unten stehenden Schleife korrigiert
		Self.GoldMedal = True
		
		'Mapnamen einlesen und gucken ob man Medaillen hat
		Local Mapname:String
		Local Map:TGameMap
		Local stream2:TStream
		While Not Eof( stream )
			'Mapobjekt erstellen
			Map = New TGameMap
			MapList.AddLast( Map )
			
			'Name einlesen und zuweisen
			Mapname = ReadLine( stream )
			Map.Name = Mapname
			
			'Temporr die Leerzeichen aus dem Namen durch _ ersetzen
			Local _Name:String = Replace( Mapname, " ", "_" )
			
			'Jeweilige Zeiten-Datei ffnen und lesen, falls mglich
			stream2 = ReadFile( "maps\times\" + _Name + ".txt" )
			If Not( stream2 = Null ) Then
				ReadLine( stream2 )							'Zeit lesen, aber nix weiter damit machen
				Map.GoldMedal = Byte( ReadLine( stream2 ) )	'Lesen, ob man die Gold-Medaille hat
				CloseFile stream2
			End If
			
			'Falls man die Goldmedaille nicht hat, hat man auch nicht alle
			If Map.GoldMedal = False Then Self.GoldMedal = False
		Wend
		
		'Mappack-Datei-Stream schlieen
		CloseFile stream
		
	End Method
	
End Type


'Map-Type
Type TGameMap
	
	'Antimaterie-Liste
	Field AntimatterList:TList
	
	'Objekt-Liste
	Field ObjectList:TList
	
	'Mapname
	Field Name:String
	
	'Zeiten in ms
	Field GoldTime:Int	'Gold-Mediallen-Zeit - wird per Script festgelegt
	Field BestTime:Int	'Bestzeit - wird aus Textdateien ausgelesen
	Field CurrTime:Int	'Aktuelle Zeit
	Field StartTime:Int	'Zeit zu der man angefangen hat
	Field LoadTime:Int	'Zeit zu der die Map geladen wurde
	
	'Ob angezeigt wird, dass man eine Gold-/Bestzeit hat
	Field ShowGold:Byte
	Field ShowBest:Byte
	
	'Ob man die Goldmedaille hat
	Field GoldMedal:Byte
	
	'Map laden
	Method LoadMap( _Name:String )
		
		'Aktuelle Map ist jetzt diese hier
		IngameState.Map = Self
		
		'Bla
		Self.ShowGold = False
		Self.ShowBest = False
		Self.BestTime = 0
		Self.GoldMedal = False
		
		'Ladezeit bestimmen und Spieler in einen Kfig sperren
		Self.LoadTime = Game.Inputs.Milliseconds
		IngameState.Player.Caged = True
		
		'Aktuelle Zeit auf 0 setzen
		Self.CurrTime = 0
		
		'Startzeit auf -1 setzen, also "nicht gestartet"
		Self.StartTime = -1
		
		'Goldzeit erstmal auf 0 setzen, wird spter vom Script bestimmt
		Self.GoldTime = 0
		
		'Listen erstellen
		Self.AntimatterList = New TList
		Self.ObjectList = New TList
		
		'Name bernehmen und Leerzeichen durch _ ersetzen, damit es keine Fehler gibt
		Self.Name = Replace( _Name, " ", "_" )
		
		lua_dofile( LuaState, "maps\" + Self.Name + ".lua" )
		'Print "debug: " + lua_tostring( LuaState, -1 )
		
		lua_getfield( LuaState, LUA_GLOBALSINDEX, Self.Name + "_init" )
		lua_pcall( LuaState, 0, 0, 0 )
		'Print "debug: " + lua_tostring( LuaState, -1 )
		
		'Bestzeit laden
		Self.LoadBestTime()
		
	End Method
	
	'Updaten
	Method Update()
		'Falls der Spieler los darf, Kfig weg machen etc
		If Game.Inputs.Milliseconds > Self.LoadTime + 500 And IngameState.Player.Caged = True Then
			IngameState.Player.Caged = False
			MoveMouse( IngameState.Player.Position.X, IngameState.Player.Position.Y )	'Maus wieder dahin bewegen
			Game.Inputs.Update()														'Inputs updaten, damit Informationen nicht veraltet sind
		End If
		
		'Objekte updaten, falls sie geupdatet werden sollen
		Local obj:TObject
		For obj = EachIn Self.ObjectList
			If obj.UpdateFlag = True Then obj.Update()
		Next
		
		'Antimaterie updaten
		Local Antimatter:TAntimatter
		For Antimatter = EachIn Self.AntimatterList
			Antimatter.Update()
			If Antimatter.Del = True Then
				ListRemove( Self.AntimatterList, Antimatter )
				Antimatter = Null
			End If
		Next
		
		'Zeit bestimmen, falls es schon angefangen hat
		If ( Self.StartTime <> -1 ) Then
			Self.CurrTime = Game.Inputs.Milliseconds - Self.StartTime
		End If
	End Method
	
	'Rendern
	Method Render()
		'Antimaterie rendern
		Local Antimatter:TAntimatter
		'Schatten
		For Antimatter = EachIn Self.AntimatterList
			Antimatter.RenderShadow()
		Next
		'Antimaterie
		For Antimatter = EachIn Self.AntimatterList
			Antimatter.Render()
		Next
		
		'Spiegel rendern
		Local Obj:TObject
		For Obj = EachIn Self.ObjectList
			If Obj.Visible = True Then Obj.Render()
		Next
		
		'Zeiten hinschreiben
		DrawText "Zeit:", 10, 10
		DrawText Self.CurrTime + " ms", 90, 10
		DrawText "Gold:", 10, 30
		DrawText Self.GoldTime + " ms", 90, 30
		
		'Nur falls es eine Bestzeit gibt, hinschreiben
		If ( Self.BestTime > 0 ) Then
			DrawText "Bestzeit: ", 10, 50
			DrawText Self.BestTime + " ms", 90, 50
		End If
		
		'Falls Level fertig, gro hinschreiben, dass man klicken soll und "Bestzeit" und "Gold-Medaille!" anzeigt, falls das zutrifft
		If Self.AntimatterList.IsEmpty() Then
			SetImageFont( Game.Ressources.BigFont )
			DrawText "Mausklick!", 512 - TextWidth( "Mausklick!" ) / 2, 60
			If Self.ShowBest = True Then DrawText "Bestzeit!", 512 - TextWidth( "Bestzeit!" ) / 2, 120
			If Self.ShowGold = True Then DrawText "Gold-Medaille!", 512 - TextWidth( "Gold-Medaille!" ) / 2, 180
			SetImageFont( Game.Ressources.NormalFont )
		End If
		
	End Method
	
	'Bestzeit laden
	Method LoadBestTime()
		Local stream:TStream = ReadFile( "maps\times\" + Self.Name + ".txt" )
		If Not( stream = Null ) Then
			Self.BestTime = Int( ReadLine( stream ) )
			Self.GoldMedal = Byte( ReadLine( stream ) )
			CloseFile stream
		End If
	End Method
	
	'Bestzeit setzen
	Method SetBestTime()
		'Zeiten ndern und in Datei speichern
		Self.BestTime = Self.CurrTime
		
		'Anzeigen lassen, dass man eine neue Bestzeit etc hat
		Self.ShowBest = True
		If ( Self.GoldMedal = False ) And ( Self.BestTime < Self.GoldTime ) Then Self.ShowGold = True
		
		Self.GoldMedal = ( Self.BestTime < Self.GoldTime )
		Local stream:TStream = WriteFile( "maps\times\" + Self.Name + ".txt" )
		If Not( stream = Null ) Then
			WriteLine( stream, String( Self.BestTime ) )
			WriteLine( stream, String( Self.GoldMedal ) )
			CloseFile stream
		End If
	End Method
	
End Type


' ================================================================= Spiel-Type ===================================================================

Type TGame
	
	'Einstellungen
	Field Settings:TProgSettings
	
	'Ressourcen
	Field Ressources:TProgRessources
	
	'Input
	Field Inputs:TProgInput
	
	'Aktueller Spielstand
	Field ActiveGamestate:TGamestate	
	
	'Ob es beendet werden soll
	Field Terminate:Byte
	
	
	'Initialisierungsmethode
	'Wird aufgerufen, wenn das Programm gestartet wird
	Method Init()
		
		'Einstellungs- und Ressourcenobjekte erstellen
		Self.Settings = New TProgSettings
		Self.Ressources = New TProgRessources
		Self.Inputs = New TProgInput
		
		
		'Einstellungen laden
		Self.Settings.Load()
		
		'Einstellungen "anwenden"
		Self.Settings.Init()
		
		'Ressourcen laden
		Self.Ressources.Load()
		
	End Method
	
	
	'Main-Methode
	Method Main()
		
		'Mainloop ausfhren bis es beendet werden soll
		While ( Self.Terminate = False )
			
			'Inputs "aktualisieren"
			Self.Inputs.Update()
			
			'Aktuellen Gamestate ausfhren
			Self.ActiveGamestate.Execute()
			
			'Warten, sodass man eine gewisse FPS hat, Buffer flippen, Backbuffer leeren
			WaitTimer Self.Settings.Frametimer
			Flip Self.Settings.VSyncEnabled
			Cls
			
		Wend
		
		'Programm Beenden
		End
		
	End Method
	
	
	'Methode um Gamestate zu ndern
	Method ChangeGamestate( Gamestate:TGamestate )
		
		Self.ActiveGamestate = Gamestate
		
	End Method
	
End Type



' ============================================================== Einstellungs-Type ===============================================================

Type TProgSettings
	
	'Fenstergre, Farbtiefe, und Vollbildeinstellung
	Field WindowWidth:Int
	Field WindowHeight:Int
	Field WindowDepth:Byte
	Field WindowFullscreen:Byte
	
	
	'Frametimer
	Field Frametimer:TTimer
	
	'Gewnschte FPS
	Field WantedFPS:Int
	
	
	'Ob VSync aktiviert ist
	Field VSyncEnabled:Byte
	
	
	'Methode um Einstellungen zu laden
	Method Load()
		
		'Fenstereinstellungen laden
		Self.WindowWidth		= 1024
		Self.WindowHeight		= 768
		Self.WindowDepth		= 32
		Self.WindowFullscreen	= 0
		
		'Gewnschte FPS laden
		Self.WantedFPS			= 60
		
		'VSync-Einstellung laden
		Self.VSyncEnabled		= True
		
	End Method
	
	
	'Methode um Fenster und so zu initialisieren
	Method Init()
		
		'Timer erstellen
		Self.Frametimer = CreateTimer( Self.WantedFPS )
		
		'Zufallsgenerator initialisieren
		SeedRnd MilliSecs()
		
		'Falls es nicht Fullscreen sein soll, Farbtiefe auf "0" setzen
		If Self.WindowFullscreen = False Then Self.WindowDepth = 0
		
		'AppTitle
		AppTitle = "Skillophant"
		
		'Grafikfenster erstellen
		Graphics Self.WindowWidth, Self.WindowHeight, Self.WindowDepth
		
		'Alphablende benutzen
		SetBlend( ALPHABLEND )
		
	End Method
	
End Type



' =============================================================== Ressourcen-Type ================================================================

Type TProgRessources
	
	'Graifken
	Field gfx_elephant:TImage
	Field gfx_mirror:TImage
	Field gfx_shadow:TImage
	Field gfx_medal:TImage
	Field gfx_cage:TImage
	Field gfx_rabbit:TImage
	
	'Schriften
	Field NormalFont:TImageFont
	Field MediumFont:TImageFont
	Field BigFont:TImageFont
	
	'Fun Facts
	Field FactList:TList
	
	'Methode um Ressourcen zu laden
	Method Load()
		
		'Alles midhandlen
		AutoMidHandle( True )
		
		Self.gfx_elephant = LoadImage( "gfx\elephant.png" )
		Self.gfx_mirror = LoadImage( "gfx\mirror.png" )
		Self.gfx_shadow = LoadImage( "gfx\shadow.png" )
		Self.gfx_medal = LoadImage( "gfx\medal.png" )
		Self.gfx_rabbit = LoadImage( "gfx\rabbit.png" )
		
		'Fonts laden
		NormalFont = LoadImageFont( "fonts\verdana.ttf", 14 )
		mediumFont = LoadImageFont( "fonts\verdana.ttf", 32 )
		BigFont = LoadImageFont( "fonts\verdanab.ttf", 48 )
		
		'Kfig-Image erstellen
		CreateCage()
		
		'Facts laden
		LoadFacts()
		
		SetColor 255,255,255
		
		'grauen hintergrund
		SetClsColor 90, 90, 90
		
	End Method
	
	'Kfig erstellen
	Method CreateCage()
		Self.gfx_cage = CreateImage( 32, 32 )
		SetColor 180, 180, 180
		DrawRect 0, 0, 32, 4
		DrawRect 0, 28, 32, 4
		Local x:Byte
		For x = 0 To 32 Step 7
			DrawRect x, 0, 4, 32
		Next
		GrabImage( Self.gfx_cage, 0, 0 )
		Cls
	End Method
	
	'Facts laden
	Method LoadFacts()
		Self.FactList = New TList
		Local stream:TStream = ReadFile( "data\facts.txt" )
		While Not Eof( stream )
			Self.FactList.AddLast( ReadLine( stream ) )
		Wend
		CloseFile stream
	End Method
	
End Type



' =================================================================== Input-Klasse ===================================================================

Type TProgInput
	
	'Maus-Position
	Field MouseXPos:Int
	Field MouseYPos:Int
	
	'Druck auf Maustasten
	Field MouseHitLeft:Byte
	
	'Druck auf Tasten
	Field KHR:Byte			'R
	Field KHEscape:Byte		'Escape
	
	'Millisekunden
	Field Milliseconds:Int
	
	'Methode um Eingaben zu "aktualisieren"
	Method Update()
		Self.MouseXPos = MouseX()
		Self.MouseYPos = MouseY()
		
		Self.MouseHitLeft = MouseHit( MOUSE_LEFT )
		
		Self.KHR = KeyHit( KEY_R )
		Self.KHEscape = KeyHit( KEY_ESCAPE )
		
		Self.Milliseconds = MilliSecs()
	End Method
	
End Type



' =============================================================== Spielstand-Type ================================================================

Type TGamestate Abstract
	
	'Methode als abstrakt definieren, da wir durch den "extendenden" Type festlegen, was hier gemacht werden soll
	Method Execute() Abstract
	
End Type



' ================================================================= Ingame-Type ==================================================================

'Ingame-State-Type
Type TStateIngame Extends TGamestate
	
	'Spieler
	Field Player:TPlayer
	
	'Map
	Field Map:TGameMap
	
	'Nummer der Map die gerade gespielt wird
	Field MapNR:Int
	
	'Initialisierung
	Method Init()
		
		'Spieler erstellen
		Self.Player = New TPlayer
		
		'Map erstellen
		Self.Map = New TGameMap
		
		'Mauszeiger ausblenden, weil der nmlich nervt
		HideMouse()
		
	End Method
	
	'Was in einem Schleifendurchlauf gemacht werden soll
	Method Execute()
		
		'Updaten
		Self.Update()
		'Rendern
		Self.Render()
		
	End Method
	
	'Spiel updaten
	Method Update()
		
		'Falls Escape oder das lustige X gedrckt wurden, zum Mappack-Men zurckkehren
		If Game.Inputs.KHEscape = True Or AppTerminate() = True Then
			MenuState.Init()
			Game.ActiveGamestate = MenuState
		End If
		
		'Spieler updaten, falls er nicht im Kfig sitzt
		If Self.Player.Caged = False Then Self.Player.Update()
		
		'Map updaten
		Self.Map.Update()
		
	End Method
	
	'Spiel rendern
	Method Render()
		
		'Map rendern
		Self.Map.Render()
		
		'Spieler rendern
		If Game.ActiveGamestate = Self Then Player.Render()
		
	End Method
	
End Type


'Men-State-Type
Type TStateMenu Extends TGamestate
	
	'Mappack-Liste
	Field MappackList:TList
	
	'Ausgewhltes Mappack; falls != Null, dann Mappack-Men ausfhren
	Field ChosenMappack:TMappack
	
	'Angewhlte Map
	Field SelectedMap:TGameMap
	
	'Ausgewhlter Fun Fact
	Field Fun_Fact:String
	
	'Initialisierung
	Method Init()
		
		'Mauszeiger einblenden
		ShowMouse()
		
		'Man hat kein Mappack ausgewhlt und auch keine Map
		Self.ChosenMappack = Null
		Self.SelectedMap = Null
		
		'Mappack-Liste erstellen
		Self.MappackList = New TList
		
		'Mappacks laden
		Local Path:String = RealPath( "mappacks\" )
		Local Files:String[] = LoadDir( Path )
		Local FileName:String
		Local File:String
		Local Mappack:TMappack
		For FileName = EachIn Files
			'Richtigen Dateinamen bestimmen
			File = Path + "/" + FileName
			
			'Falls es eine Datei ist
			If FileType( File ) = 1 Then
				Mappack = New TMappack
				MappackList.AddLast( Mappack )
				Mappack.Load( FileName )
			End If
		Next
		
		'Zuflligen Fun Fact auswhlen
		Self.Fun_Fact = String( Game.Ressources.FactList.ValueAtIndex( Rand( 0, CountList( Game.Ressources.FactList ) - 1 ) ) )
		
	End Method
	
	'Was in einem Schleifendurchlauf gemacht werden soll
	Method Execute()
		
		'Updaten
		Self.Update()
		'Rendern
		Self.Render()
		
	End Method
	
	'Spiel updaten
	Method Update()
		
		'Falls Escape oder das lustige X gedrckt wurden, Spiel beenden, nicht, falls man sich im Mappack-Men aufhlt
		If Game.Inputs.KHEscape = True Or AppTerminate() = True Then
			If Self.ChosenMappack <> Null Then
				Self.ChosenMappack = Null
			Else
				Game.Terminate = True
			End If
		End If
		
		'Falls man kein Mappack ausgewhlt hat
		If Self.ChosenMappack = Null Then
			'Gucken, ob man ein Mappack anwhlt
			Local Mappack:TMappack
			Local SelMappack:TMappack
			Local Y:Int = 250
			For Mappack = EachIn Self.MappackList
				'Falls man die Maus im Mappack-Auswahl-Bereich hat und genau dieses Mappack auswhlt
				If Game.Inputs.MouseXPos > 70 And Game.Inputs.MouseXPos < 300 And Game.Inputs.MouseYPos > Y - 16 And Game.Inputs.MouseYPos < Y + 16 Then
					Mappack.Selected = True
					SelMappack = Mappack
				Else
					Mappack.Selected = False
				End If
				Y :+ 50			'Nchstes Mappack ist weiter unten
			Next
			
			'Falls man klickt und eins ausgewhlt hat, quasi ins nchste Men wechseln
			If Game.Inputs.MouseHitLeft = True And SelMappack <> Null Then
				Self.ChosenMappack = SelMappack
			End If
		Else
			'Ansonsten gucken, ob man eine Map anwhlt
			Local Map:TGameMap
			Local Y:Int = 250
			For Map = EachIn Self.ChosenMappack.MapList
				'Falls man die Maus im Map-Auswahl-Bereich hat und genau diese Map auswhlt
				If Game.Inputs.MouseXPos > 70 And Game.Inputs.MouseXPos < 300 And Game.Inputs.MouseYPos > Y - 16 And Game.Inputs.MouseYPos < Y + 16 Then
					Self.SelectedMap = Map
				Else
					If Self.SelectedMap = Map Then Self.SelectedMap = Null
				End If
				Y :+ 50			'Nchstes Mappack ist weiter unten
			Next
			
			'Falls man klickt und eins ausgewhlt hat, ins Spiel wechseln
			If Game.Inputs.MouseHitLeft = True And Self.SelectedMap <> Null Then
				IngameState.Init()
				IngameState.Map.LoadMap( Self.SelectedMap.Name )
				IngameState.MapNR = ( Game.Inputs.MouseYPos - 225 ) / 50
				Game.ActiveGamestate = IngameState
			End If
		End If
		
	End Method
	
	'Spiel rendern
	Method Render()
		
		'Groe Schrift whlen und berschrift malen
		SetImageFont( Game.Ressources.BigFont )
		SetColor 0, 0, 0
		SetScale 1.03, 1.03
		DrawText "Skillophant", 512 - TextWidth( "Skillophant" )*1.03 / 2, 50
		SetScale 1, 1
		SetColor 255, 255, 255
		DrawText "Skillophant", 512 - TextWidth( "Skillophant" ) / 2, 50
		SetScale 1.2, 1.2
		DrawImage Game.Ressources.gfx_elephant, 491, 86
		SetScale 1, 1
		
		'Falls man kein Mappack ausgewhlt hat
		If Self.ChosenMappack = Null Then
			'Mittlere Schrift whlen und Untermenname schreiben
			SetImageFont( Game.Ressources.MediumFont )
			DrawText "Mappackauswahl", 512 - TextWidth( "Mappackauswahl" ) / 2, 120
			
			'Normale Schrift whlen
			SetImageFont( Game.Ressources.NormalFont )
			
			'Mappacks darstellen
			Local Mappack:TMappack
			Local Y:Int = 250
			For Mappack = EachIn Self.MappackList
				If Mappack.Selected = True Then SetColor 0, 255, 255								'Farbe auf Cyan ndern, falls Mappack ausgewhlt
				DrawText Mappack.Name, 120, Y - 8													'Name hinschreiben
				SetColor 255, 255, 255																'Farbe wieder auf wei ndern
				If Mappack.GoldMedal = True Then DrawImage Game.Ressources.gfx_medal, 100, Y		'Medaille malen, falls man sie hat
				Y :+ 50																				'Nchstes Mappack weiter unten
			Next
		Else
			'Ansonsten Maps im Mappack darstellen
			'Mittlere Schrift whlen und Untermenname schreiben
			SetImageFont( Game.Ressources.MediumFont )
			DrawText "Mapauswahl", 512 - TextWidth( "Mapauswahl" ) / 2, 120
			
			'Normale Schrift whlen
			SetImageFont( Game.Ressources.NormalFont )
			
			Local Map:TGameMap
			Local Y:Int = 250
			For Map = EachIn Self.ChosenMappack.MapList
				If Map = Self.SelectedMap Then SetColor 0, 255, 255									'Farbe auf Cyan ndern, falls Map ausgewhlt
				DrawText Map.Name, 120, Y - 8														'Name hinschreiben
				SetColor 255, 255, 255																'Farbe wieder auf wei ndern
				If Map.GoldMedal = True Then DrawImage Game.Ressources.gfx_medal, 100, Y			'Medaille malen, falls man sie hat
				Y :+ 50																				'Nchste Map weiter unten
			Next
		End If
		
		'Fun Fact
		'Mittlere Schrift
		SetImageFont( Game.Ressources.MediumFont )
		DrawText "Fun Fact", 700, 230
			
		'Normale Schrift whlen
		SetImageFont( Game.Ressources.NormalFont )
		DrawText Self.Fun_Fact, 700, 280
		
	End Method
	
End Type

'"Mappack-Abgeschlossen"-Gamestate-Type
Type TStateWin Extends TGamestate
	
	'Was in einem Schleifendurchlauf gemacht werden soll
	Method Execute()
		
		'Updaten
		Self.Update()
		'Rendern
		Self.Render()
		
	End Method
	
	'Updaten
	Method Update()
		
		'Falls Escape, das lustige X oder die linke Maustaste gedrckt wurden, zum Men zurckkehren
		If Game.Inputs.KHEscape = True Or AppTerminate() = True Or Game.Inputs.MouseHitLeft = True Then
			MenuState.Init()
			Game.ActiveGamestate = MenuState
		End If
		
	End Method
	
	'Rendern
	Method Render()
		
		SetImageFont( game.ressources.bigfont )
		DrawText( "Mappack abgeschlossen.", 512 - TextWidth( "Mappack abgeschlossen." ) / 2, 150 )
		SetImageFont( game.ressources.mediumfont )
		DrawText( "Mit Mausklick! gehts weiter.", 512 - TextWidth( "Mit Mausklick! gehts weiter." ) / 2, 250 )
		
	End Method
	
End Type


'=====

'LUA-VM initialisieren
Global LuaState:Byte Ptr
InitLUAVM()

'Game-Objekt erstellen und initialisieren 
Global Game:TGame = New TGame
Game.Init()

'Men-Gamestate-Objekt ...
Global MenuState:TStateMenu = New TStateMenu
MenuState.Init()

'Ingame-Gamestate-Objekt und Win-Objekt erstellen
Global IngameState:TStateIngame = New TStateIngame
Global WinState:TStateWin = New TStateWin



'Aktuellen Gamestate auf das IngameState-Objekt setzen
Game.ActiveGamestate = MenuState

'Starten
Game.Main()

' ================================================================= Funktionen ===================================================================

'LUA-VM initialisieren
Function InitLUAVM()
	
	LuaState = luaL_newstate()
	luaL_openlibs( LuaState )
	
	'Befehle registrieren
	lua_register( LuaState, "AddAntimatter", AddAntimatter )
	lua_register( LuaState, "SetPlayerPosition", SetPlayerPosition )
	lua_register( LuaState, "AddObject", AddObject )
	lua_register( LuaState, "AddSegment", AddSegment )
	lua_register( LuaState, "UpdateObject", UpdateObject )
	lua_register( LuaState, "UpdateSegment", UpdateSegment )
	lua_register( LuaState, "GetSegInfo", GetSegInfo )
	lua_register( LuaState, "SetObjectUpdate", SetObjectUpdate )
	lua_register( LuaState, "GetPlayerX", GetPlayerX )
	lua_register( LuaState, "GetPlayerY", GetPlayerY )
	lua_register( LuaState, "SetGoldTime", SetGoldTime )
	lua_register( LuaState, "AddSprite", AddSprite )
	lua_register( LuaState, "UpdateSprite", UpdateSprite )
	lua_register( LuaState, "AddTextSprite", AddTextSprite )
	lua_register( LuaState, "SetObjectVisibility", SetObjectVisibility )
	lua_register( LuaState, "GetObjectTags", GetObjectTags )
	lua_register( LuaState, "GetMilliseconds", GetMilliseconds )
		
	lua_register( LuaState, "output", output )
	
End Function

'Spielerposition setzen per LUA
Function SetPlayerPosition( _LuaState:Byte Ptr )
	'Koordinaten einlesen
	Local X:Int = luaL_checkinteger( _LuaState, 1 )
	Local Y:Int = luaL_checkinteger( _LuaState, 2 )
	
	'Spielerposition verndern
	IngameState.Player.SetPosition( X, Y )
End Function

'Antimaterie hinzufgen per LUA
Function AddAntimatter( _LuaState:Byte Ptr )
	'Koordinaten einlesen
	Local X:Int = luaL_checkinteger( _LuaState, 1 )
	Local Y:Int = luaL_checkinteger( _LuaState, 2 )
	
	'Neue Antimaterie hinzufgen und der Liste hinzufgen
	Local Antimatter:TAntimatter = New TAntimatter
	IngameState.Map.AntimatterList.AddLast( Antimatter )
	Antimatter.Init( X, Y )
End Function

'Spiegel hinzufgen per LUA
Function AddObject( _LuaState:Byte Ptr )
	'Objekt erstellen und der Objektliste der Map hinzufgen
	Local obj:TObject = New TObject
	IngameState.Map.ObjectList.AddLast( obj )
	
	'Name und ID einlesen
	obj.Name = luaL_checkstring( _LuaState, 1 )
	obj.ID = luaL_checkinteger( _LuaState, 2 )
	
	'Tags einlesen 
	Local countTags:Int = luaL_checkinteger( _LuaState, 3 )
	obj.Tags = New Int[ countTags ]
	Local i:Int
	For i = 0 To countTags - 1
		obj.Tags[ i ] = luaL_checkinteger( _LuaState, 4 + i )
	Next
	
	'entsprechendes Script einlesen
	luaL_dofile( _LuaState, "mirrors\" + obj.Name + ".lua" )
	
	'Init-Funktion aufrufen
	lua_getfield( LuaState, LUA_GLOBALSINDEX, obj.Name + "_init" )
	lua_pushinteger( LuaState, obj.ID )		'ID bergeben
	For i = 0 To countTags - 1				'Tags bergeben
		lua_pushnumber( LuaState, obj.Tags[ i ] )
	Next
	lua_pcall( LuaState, 1 + countTags, 0, 0 )
	
	'Print "debug: " + lua_tostring( LuaState, -2 )
End Function

'Segment hinzufgen per LUA
Function AddSegment( _LuaState:Byte Ptr )
	'Objekt ID, Segment ID, Position und Rotation auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local sID:Int = luaL_checkinteger( _LuaState, 2 )
	Local X:Int = luaL_checkinteger( _LuaState, 3 )
	Local Y:Int = luaL_checkinteger( _LuaState, 4 )
	Local Rot:Float = luaL_checknumber( _LuaState, 5 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Segment erstellen und Objekt hinzufgen
	Local seg:TSegment = New TSegment
	seg.Init( sID, New TVector.Init( X, Y ), Rot )
	obj.SegmentList.AddLast( seg )
End Function

'Objekt updaten per LUA
Function UpdateObject( _LuaState:Byte Ptr )
	'Objekt ID auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Objekttags updaten
	obj.UpdateTags( _LuaState )
End Function

'Segment updaten per LUA
Function UpdateSegment( _LuaState:Byte Ptr )
	'Objekt ID, Segment ID, Position und Rotation auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local sID:Int = luaL_checkinteger( _LuaState, 2 )
	Local X:Int = luaL_checkinteger( _LuaState, 3 )
	Local Y:Int = luaL_checkinteger( _LuaState, 4 )
	Local Rot:Float = luaL_checknumber( _LuaState, 5 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Segment herausfinden
	Local seg:TSegment
	For seg = EachIn obj.SegmentList
		If seg.ID = sID Then Exit
	Next
	
	'Position und Rotation verndern
	seg.ChangePosRot( New TVector.Init( X, Y ), Rot )
End Function

'Segment-X-Position herausfinden
Function GetSegInfo:Int( _LuaState:Byte Ptr )
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local sID:Int = luaL_checkinteger( _LuaState, 2 )
	Local Info:Int = luaL_checkinteger( _LuaState, 3 )	' 0 = X, 1 = Y, 2 = Rotation
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Segment herausfinden
	Local seg:TSegment
	For seg = EachIn obj.SegmentList
		If seg.ID = sID Then Exit
	Next
	
	'Rckgabe wert ermitteln und zurckgeben
	Local ret:Int
	Select Info
		Case 0; ret = seg.MP.X
		Case 1; ret = seg.MP.Y
		Case 2; ret = seg.Rotation
	End Select
	
	lua_pushnumber( _LuaState, ret )
	Return 1
End Function

'Setzen des UpdateFlags eines Objects per LUA
Function SetObjectUpdate( _LuaState:Byte Ptr )
	'Objekt ID, Segment ID, Position und Rotation auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local Update:Byte = luaL_checkinteger( _LuaState, 2 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Flag setzem
	obj.UpdateFlag = Update
End Function

'Spieler-X-Position an LUA-Script senden
Function GetPlayerX:Int( _LuaState:Byte Ptr )
	lua_pushnumber( _LuaState, IngameState.Player.Position.X )
	Return 1
End Function

'Spieler-Y-Position an LUA-Script senden
Function GetPlayerY:Int( _LuaState:Byte Ptr )
	lua_pushnumber( _LuaState, IngameState.Player.Position.Y )
	Return 1
End Function

'Goldzeit der aktuellen Map bestimmen
Function SetGoldTime( _LuaState:Byte Ptr )
	IngameState.Map.GoldTime = luaL_checkinteger( _LuaState, 1 )
End Function

'Sprite hinzufgen
Function AddSprite( _LuaState:Byte Ptr )
	'Objekt ID, Sprite ID, imgSource, Position und Rotation auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local sID:Int = luaL_checkinteger( _LuaState, 2 )
	Local imgSource:String = luaL_checkstring( _LuaState, 3 )
	Local X:Int = luaL_checkinteger( _LuaState, 4 )
	Local Y:Int = luaL_checkinteger( _LuaState, 5 )
	Local Rot:Float = luaL_checknumber( _LuaState, 6 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Bild laden
	Local img:TImage = LoadImage( imgSource )
	
	'Sprite erstellen und Objekt hinzufgen
	Local sprite:TSprite = New TSprite
	sprite.Init( sID, img, New TVector.Init( X, Y ), Rot )
	obj.SpriteList.AddLast( sprite )
End Function

'Sprite updaten
Function UpdateSprite( _LuaState:Byte Ptr )
	'Objekt ID, Sprite ID, Position und Rotation auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local sID:Int = luaL_checkinteger( _LuaState, 2 )
	Local X:Int = luaL_checkinteger( _LuaState, 3 )
	Local Y:Int = luaL_checkinteger( _LuaState, 4 )
	Local Rot:Float = luaL_checknumber( _LuaState, 5 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Sprite herausfinden
	Local sprite:TSprite
	For sprite = EachIn obj.SpriteList
		If sprite.ID = sID Then Exit
	Next
	
	'Position und Rotation verndern
	sprite.ChangePosRot( New TVector.Init( X, Y ), Rot )
End Function

'Text-Sprite hinzufgen
Function AddTextSprite( _LuaState:Byte Ptr )
	'Objekt ID, Sprite ID, Text, Position und Rotation auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local sID:Int = luaL_checkinteger( _LuaState, 2 )
	Local Txt:String = luaL_checkstring( _LuaState, 3 )
	Local X:Int = luaL_checkinteger( _LuaState, 4 )
	Local Y:Int = luaL_checkinteger( _LuaState, 5 )
	Local Rot:Float = luaL_checknumber( _LuaState, 6 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Text-Image erstellen
	Local img:TImage = CreateImage( TextWidth( Txt ), TextHeight( Txt ) + 5 )
	DrawText Txt, 0, 0
	GrabImage( img, 0, 0 )
	Cls
	
	'Sprite erstellen und Objekt hinzufgen
	Local sprite:TSprite = New TSprite
	sprite.Init( sID, img, New TVector.Init( X, Y ), Rot )
	obj.SpriteList.AddLast( sprite )
End Function

'Objekt-Sichtbarkeit bestimmen
Function SetObjectVisibility( _LuaState:Byte Ptr )
	'Objekt ID und Visibility auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local Visibility:Int = luaL_checkinteger( _LuaState, 2 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	obj.Visible = Visibility
End Function

'Object-Tags rausgeben
Function GetObjectTags:Int( _LuaState:Byte Ptr )
	'Objekt ID und TagNR auslesen
	Local oID:Int = luaL_checkinteger( _LuaState, 1 )
	Local TagNR:Int = luaL_checkinteger( _LuaState, 2 )
	
	'Objekt herausfinden
	Local obj:TObject
	For obj = EachIn IngameState.Map.ObjectList
		If obj.ID = oID Then Exit
	Next
	
	'Tag pushen
	lua_pushinteger( _LuaState, obj.Tags[TagNR] )
	Return 1
End Function

'Millisekunden bergeben
Function GetMilliseconds:Int( _LuaState:Byte Ptr )
	lua_pushnumber( _LuaState, Game.Inputs.Milliseconds )
	Return 1
End Function

'Text ausgeben
Function output(_luastate:Byte Ptr)
Print luaL_checkstring(_luastate,1)
End Function


'Kreis-Kreis-Kollisions-Abfrage
Function CircleCircleCollision:Byte( P1:TVector, R1:Int, P2:TVector, R2:Int )
	Local Dist:Float = Sqr( ( P2.X-P1.X )*( P2.X-P1.X ) + ( P2.Y-P1.Y )*( P2.Y-P1.Y ) )
	If Dist <= R1 + R2 Then Return True
	Return False
End Function

'Linie-Linie-Kollisions-Abfrage
Function LinesCollide:Byte( x1#, y1#, x2#, y2#, x3#, y3#, x4#, y4# )'B1:TVector, E1:TVector, B2:TVector, E2:TVector )
	'Local x1# = B1.X, y1# = B1.Y, x2# = E1.X, y2# = E1.Y, x3# = B2.X, y3# = B2.Y, x4# = E2.X, y4# = E2.Y
	If x1=x2 And x3=x4 And x1=x3 And Min(y1,y2)<=Max(y3,y4) And Max(y1,y2)>=Min(y3,y4) Then Return 1
	If x1=x2 And y3=y4 And x1>=Min(x3,x4) And x1<=Max(x3,x4) And Min(y1,y2)<=y3 And Max(y1,y2)=>y3 Then Return 1
	If x3=x4 And y1=y2 And x3>=Min(x1,x2) And x3<=Max(x1,x2) And Min(y3,y4)<=y1 And Max(y3,y4)=>y1 Then Return 1
	If x1=x2 Then x1=x1+0.1
	If x3=x4 Then x3=x3+0.1
	Local m1# = (y1-y2)/(x1-x2)
	Local m2# = (y3-y4)/(x3-x4)
	Local c1# = y1 - m1 * x1
	Local c2# = y3 - m2 * x3
	If m1=m2 Then m1=m1+0.0001
	Local x# = (c2 - c1) / (m1 - m2)
	Local y# = x * m1 + c1
	If Abs(x-x1)<=Abs(x1-x2) And Abs(x-x2)<=Abs(x1-x2) Then
	If Abs(y-y1)<=Abs(y1-y2) And Abs(y-y2)<=Abs(y1-y2) Then
	If Abs(x-x3)<=Abs(x3-x4) And Abs(x-x4)<=Abs(x3-x4) Then
	If Abs(y-y3)<=Abs(y3-y4) And Abs(y-y4)<=Abs(y3-y4) Then
	Return 1;End If;End If;End If;End If
End Function

'Linie-Kreis-Kollisions-Abfrage
Function CircleIntersect:Byte(sx#,sy#,dx#,dy#,kx#,ky#,Radius#) 
	If dx > 0 Then 
		If kx+Radius < sx Or kx-Radius > sx+dx Then Return 0
	Else
		If kx-Radius > sx Or kx+Radius < sx+dx Then Return 0
	End If
	
	If dy > 0 Then 
		If ky+Radius < sy Or ky-Radius > sy+dy Then Return 0
	Else
		If ky-Radius > sy Or ky+Radius < sy+dy Then Return 0
	End If
	
	Local a# = dx*dx + dy*dy
	Local b# = 2.0 * dx * (sx - kx) + 2.0 * dy * (sy - ky)
	Local c# = kx*kx + ky*ky + sx*sx + sy*sy - 2.0 * (kx * sx + ky * sy) - Radius*Radius
	Local discriminant# = b*b - 4.0 * a * c
	
	Return( discriminant > 0.0 )
End Function