Function DrawLightFast(poly#[], mx#, my#, fade# = .8)
  SetBlend LIGHTBLEND
  Local inner#[poly.length]
  For Local i%=0 Until poly.length Step 2
    Local x# = poly[i  ]
    Local y# = poly[i+1]
    Local vx# = x-mx, vy# = y-my
    vx :* fade
    vy :* fade
    x = mx+vx
    y = my+vy
    inner[i] = x
    inner[i+1] = y
  Next
  DrawPoly inner
  Local r%, g%, b%
  GetColor r, g, b
  glBegin GL_TRIANGLE_STRIP
  For Local i%=0 To poly.length Step 2
    Local index% = i Mod poly.length
    SetColor 0, 0, 0
    glVertex2f poly[index], poly[index+1]
    SetColor r, g, b
    glVertex2f inner[index], inner[index+1]
  Next
  glEnd
End Function
Function DrawLight(poly#[], fade# = .8)
  Local mx#, my#
  GetPolyMiddle poly, mx, my
  DrawLightFast poly, mx, my, fade
End Function
Function GetPolyMiddle(poly#[], mx# Var, my# Var)
  Local sx#, sy#
  For Local i%=0 Until poly.length Step 2
    sx :+ poly[i  ]
    sy :+ poly[i+1]
  Next
  mx = sx/poly.length*2
  my = sy/poly.length*2
End Function
Function ComputeFlashlight#[](x#, y#, dir#, angle#, radius#, stp# = 1.0)

  Local leftAng# = dir-angle*.5, rightAng# = dir+angle*.5

  Local addPoints% = angle/stp
  Local result#[addPoints*2+6]
  result[0] = x
  result[1] = y
  result[2] = x+Sin(leftAng)*radius
  result[3] = y+Cos(leftAng)*radius
  Local ang# = leftAng
  For Local i%=0 Until addPoints
    result[4+i*2] = x+Sin(ang)*radius
    result[5+i*2] = y+Cos(ang)*radius
    ang :+ stp
  Next
  result[result.length-2] = x+Sin(rightAng)*radius
  result[result.length-1] = y+Cos(rightAng)*radius
  Return result
End Function